#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
//uniform float u_hueshift;
//uniform float u_saturation; // Para no tocarlo tiene que ser 1.0
uniform vec3 u_rt;
uniform vec3 u_gt;
uniform vec3 u_bt;

/*
vec3 rgb2hsv(vec3 c)
{
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));
    
    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

void main()
{
    vec4 textureColor = texture2D(CC_Texture0, v_texCoord) * v_fragmentColor;
    vec3 fragRGB = textureColor.rgb;
    vec3 fragHSV = rgb2hsv(fragRGB).xyz;
    vec3 vHSV = vec3(mod(CC_Time.a * 20.0, 360.0), 1.0, 1.0);
    fragHSV.x += vHSV.x / 360.0;
    fragHSV.yz *= vHSV.yz;
    fragHSV.x = mod(fragHSV.x, 1.0);
    fragHSV.y = clamp(fragHSV.y, 0.0, 1.0);
    fragHSV.z = clamp(fragHSV.z, 0.0, 1.0);
    fragRGB = hsv2rgb(fragHSV);
    gl_FragColor = vec4(fragRGB, textureColor.w);
}
*/

void main()
{    
    // Aproximación por transformaciones lineales
//    vec4 textureColor = texture2D(CC_Texture0, v_texCoord) * v_fragmentColor;
//    float satU = u_saturation * cos(u_hueshift);
//    float satW = u_saturation * sin(u_hueshift);
//    
//    gl_FragColor = vec4((0.299 + 0.701 * satU + 0.168 * satW) * textureColor.r + (0.587 - 0.587 * satU + 0.330 * satW) * textureColor.g + (0.114 - 0.114 * satU - 0.497 * satW) * textureColor.b,
//                        (0.299 - 0.299 * satU - 0.328 * satW) * textureColor.r + (0.587 + 0.413 * satU + 0.035 * satW) * textureColor.g + (0.114 - 0.114 * satU + 0.292 * satW) * textureColor.b,
//                        (0.299 - 0.300 * satU + 1.250 * satW) * textureColor.r + (0.587 - 0.588 * satU - 1.050 * satW) * textureColor.g + (0.114 + 0.886 * satU - 0.203 * satW) * textureColor.b,
//                        textureColor.a);
    
    // Para optimizar el shader se precalcula en CPU u_rt, r_gt y u_bt (mirar ColorUtil).
    vec4 textureColor = texture2D(CC_Texture0, v_texCoord) * v_fragmentColor;
    gl_FragColor = vec4(u_rt.r * textureColor.r + u_rt.g * textureColor.g + u_rt.b * textureColor.b,
                        u_gt.r * textureColor.r + u_gt.g * textureColor.g + u_gt.b * textureColor.b,
                        u_bt.r * textureColor.r + u_bt.g * textureColor.g + u_bt.b * textureColor.b,
                        textureColor.a);
}
