#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform vec3 u_rt;
uniform vec3 u_gt;
uniform vec3 u_bt;

void main()
{
    // Para optimizar el shader se precalcula en CPU u_rt, r_gt y u_bt (mirar ColorUtil).
    vec4 textureColor = texture2D(CC_Texture0, v_texCoord) * v_fragmentColor;
    gl_FragColor = vec4(u_rt.r * textureColor.r + u_rt.g * textureColor.g + u_rt.b * textureColor.b,
                        u_gt.r * textureColor.r + u_gt.g * textureColor.g + u_gt.b * textureColor.b,
                        u_bt.r * textureColor.r + u_bt.g * textureColor.g + u_bt.b * textureColor.b,
                        textureColor.a);
}