#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 u_topLeft;
uniform vec2 u_size;
uniform vec4 u_thresholds; // Izquierda - Derecha - Arriba - Abajo

void main()
{
    vec4 color = texture2D(CC_Texture0, v_texCoord);
    
    vec2 normalizedTexCoord = (v_texCoord - u_topLeft) / u_size;
    float leftThreshold = u_thresholds.x;
    float rightThreshold = u_thresholds.y;
    float topThreshold = u_thresholds.z;
    float bottomThreshold = u_thresholds.w;
    
    // #TODO# optimizar
    if(normalizedTexCoord.x < leftThreshold)
    {
        color.a = color.a * normalizedTexCoord.x / leftThreshold;
    }
    else if(normalizedTexCoord.x > rightThreshold)
    {
        color.a = color.a * (1.0 - normalizedTexCoord.x) / (1.0 - rightThreshold);
    }
    
    if(normalizedTexCoord.y < topThreshold)
    {
        color.a = color.a * normalizedTexCoord.y / topThreshold;
    }
    else if(normalizedTexCoord.y > bottomThreshold)
    {
        color.a = color.a * (1.0 - normalizedTexCoord.y) / (1.0 - bottomThreshold);
    }
    
    gl_FragColor = color * v_fragmentColor;
}